/// <reference types="react" />
import * as React from 'react';
export interface Point {
    x: number;
    y: number;
}
export interface ParallaxRange {
    start: number;
    end: number;
    beginX: number;
    beginY: number;
    x: number;
    y: number;
    radius?: number;
    angle?: number;
    direction?: boolean;
    step?: number;
    linkClass?: string;
    page?: boolean;
    points?: Point[];
}
export interface Props {
    map: ParallaxRange[];
    currentScroll: number;
    layerClassName?: string;
    layerZIndex?: number;
}
export interface State {
    x: number;
    y: number;
    map: ParallaxRange[];
}
export declare class ParallaxMap extends React.Component<Props, State> {
    state: State;
    static defaultProps: {
        layerClassName: string;
        layerZIndex: number;
    };
    componentDidMount(): void;
    componentWillReceiveProps(nexrProps: any): void;
    private getPoints(radius, direction, angle, step);
    private convertMapForRadius(map);
    private calculate();
    render(): JSX.Element;
}
